<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWhoTracksWhatPerDispatcherItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfWhoTracksWhatPerDispatcherItem extends AbstractStructArrayBase
{
    /**
     * The WhoTracksWhatPerDispatcherItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WhoTracksWhatPerDispatcherItem[]
     */
    public $WhoTracksWhatPerDispatcherItem;
    /**
     * Constructor method for ArrayOfWhoTracksWhatPerDispatcherItem
     * @uses ArrayOfWhoTracksWhatPerDispatcherItem::setWhoTracksWhatPerDispatcherItem()
     * @param \StructType\WhoTracksWhatPerDispatcherItem[] $whoTracksWhatPerDispatcherItem
     */
    public function __construct(array $whoTracksWhatPerDispatcherItem = array())
    {
        $this
            ->setWhoTracksWhatPerDispatcherItem($whoTracksWhatPerDispatcherItem);
    }
    /**
     * Get WhoTracksWhatPerDispatcherItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WhoTracksWhatPerDispatcherItem[]|null
     */
    public function getWhoTracksWhatPerDispatcherItem()
    {
        return isset($this->WhoTracksWhatPerDispatcherItem) ? $this->WhoTracksWhatPerDispatcherItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWhoTracksWhatPerDispatcherItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWhoTracksWhatPerDispatcherItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWhoTracksWhatPerDispatcherItemForArrayConstraintsFromSetWhoTracksWhatPerDispatcherItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWhoTracksWhatPerDispatcherItemWhoTracksWhatPerDispatcherItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfWhoTracksWhatPerDispatcherItemWhoTracksWhatPerDispatcherItemItem instanceof \StructType\WhoTracksWhatPerDispatcherItem) {
                $invalidValues[] = is_object($arrayOfWhoTracksWhatPerDispatcherItemWhoTracksWhatPerDispatcherItemItem) ? get_class($arrayOfWhoTracksWhatPerDispatcherItemWhoTracksWhatPerDispatcherItemItem) : sprintf('%s(%s)', gettype($arrayOfWhoTracksWhatPerDispatcherItemWhoTracksWhatPerDispatcherItemItem), var_export($arrayOfWhoTracksWhatPerDispatcherItemWhoTracksWhatPerDispatcherItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WhoTracksWhatPerDispatcherItem property can only contain items of type \StructType\WhoTracksWhatPerDispatcherItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WhoTracksWhatPerDispatcherItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WhoTracksWhatPerDispatcherItem[] $whoTracksWhatPerDispatcherItem
     * @return \ArrayType\ArrayOfWhoTracksWhatPerDispatcherItem
     */
    public function setWhoTracksWhatPerDispatcherItem(array $whoTracksWhatPerDispatcherItem = array())
    {
        // validation for constraint: array
        if ('' !== ($whoTracksWhatPerDispatcherItemArrayErrorMessage = self::validateWhoTracksWhatPerDispatcherItemForArrayConstraintsFromSetWhoTracksWhatPerDispatcherItem($whoTracksWhatPerDispatcherItem))) {
            throw new \InvalidArgumentException($whoTracksWhatPerDispatcherItemArrayErrorMessage, __LINE__);
        }
        if (is_null($whoTracksWhatPerDispatcherItem) || (is_array($whoTracksWhatPerDispatcherItem) && empty($whoTracksWhatPerDispatcherItem))) {
            unset($this->WhoTracksWhatPerDispatcherItem);
        } else {
            $this->WhoTracksWhatPerDispatcherItem = $whoTracksWhatPerDispatcherItem;
        }
        return $this;
    }
    /**
     * Add item to WhoTracksWhatPerDispatcherItem value
     * @throws \InvalidArgumentException
     * @param \StructType\WhoTracksWhatPerDispatcherItem $item
     * @return \ArrayType\ArrayOfWhoTracksWhatPerDispatcherItem
     */
    public function addToWhoTracksWhatPerDispatcherItem(\StructType\WhoTracksWhatPerDispatcherItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WhoTracksWhatPerDispatcherItem) {
            throw new \InvalidArgumentException(sprintf('The WhoTracksWhatPerDispatcherItem property can only contain items of type \StructType\WhoTracksWhatPerDispatcherItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WhoTracksWhatPerDispatcherItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WhoTracksWhatPerDispatcherItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WhoTracksWhatPerDispatcherItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WhoTracksWhatPerDispatcherItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WhoTracksWhatPerDispatcherItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WhoTracksWhatPerDispatcherItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WhoTracksWhatPerDispatcherItem
     */
    public function getAttributeName()
    {
        return 'WhoTracksWhatPerDispatcherItem';
    }
}
